# Contributing

BallotAPI is a critical project that aims to become the core ballot dataset for thousands of apps, projects, and websites. We will the help of many different types of contributers, and this document describes how each can best help out the BallotAPI initiative.

### Public Domain

BallotAPI's code and database are released into the public domain unless otherwise stated. If you want to contribute to either of those things (e.g. submit code or dataset updates), you must be okay with your contributions being released to the public domain.

### Code of Conduct

To contribute, you must follow Open Austin's [Code of Conduct](https://www.open-austin.org/about/#code-of-conduct) and [Anti-Harassment Policy](https://www.open-austin.org/about/#anti-harassment-policy)

## Contributing as a dataset maintainer

Every election in the United States, there's new ballots and precinct maps that need to be added and updated in our core ballot dataset. Dataset Maintainers are contributers who help update, review, and maintain our ballot dataset. Right now, we are still in prototype development, so we don't have a huge need for volunteer dataset maintainers, but eventually we expect this category of contributers to become the majority of people working on the project. If you're interested in eventually helping contribute as a dataset maintainer, please check back to see when we're ready to get our first contributors going!

## Contributing as a software developer

If you want to contribute to our software repositories (api server, website, tooling, testing, etc.), we would love the help! We maintain our development projects through our [project tracker](https://github.com/open-austin/ballotapi/projects) and [issue tracker](https://github.com/open-austin/ballotapi/issues). Please check those out to see if any of the projects or issues are something you'd be interested in working on. If so, please add a comment to the particular issue you want to help contribute to.

In general, we want to keep the core API server codebase extremely simple (since it is the thing that others depend on), so we're not looking to add a bunch of features and complexities to the core API server. However, we are looking to have a ton of software tools to help people review, update, and maintain our core ballot dataset. These maintenance tools are where we expect the vast majority of software development to happen, and they don't have to be nearly as optimized as the core API server. So if you're looking to help contribute as, contributing to tooling is probably the best place to start.

## Contributing as a designer

While BallotAPI is mainly targeted to be used by other developers, we still want to have a fantastic user experience for our website, documentation, and maintenance tools. If you have UI/UX design experience, we would love your help! Please check out our [help wanted](https://github.com/open-austin/ballotapi/issues?q=is%3Aissue+is%3Aopen+label%3A%22help+wanted%22) issues to see if any are design-related, and you feel you could contribute to.

## Contributing as a fundraiser

Maintaining a public domain dataset of all ballots in the United States is extremely difficult. This is not a set-and-forget project, and it requires constant upkeep by both software developers and dataset maintainers. While some of us are working on this project as volunteers, we would love to be able to have a paid staff that can be dedicated to keeping this project running. If you are interested in helping fund or contribute to fundraising efforts for BallotAPI, please email us at donate@ballotapi.org.

## Contributing as a policy expert

Ballots in the United States are highly fragmented across states and counties. Ballots may seem simple but they are highly complex political documents. We need advice and help from experts who know the complexities and policies surrounding elections and ballot information. If you have that kind of experience and want to help contribute to BallotAPI as a policy expert or resource, please email us at volunteer@ballotapi.org.

