# BallotAPI - Ballots for developers

**NOTE: THIS PROJECT IS UNDER DEVELOPMENT. THE API DOES NOT WORK YET.**

Main website: https://ballotapi.org/

## What is BallotAPI?
BallotAPI exactly what it sounds like: a ballot API. More specifically,
it is a public domain database and REST API of election and ballot
information in the United States. The goal of this project is to allow
developers to integrate up-to-date election and ballot information into their
apps and websites.

This project is maintained by [Open Austin](https://www.open-austin.org),
a [Code for America](https://www.codeforamerica.org/) brigade.

## Current Status
* [x] Docs - what the API should do ([see project](https://github.com/open-austin/ballotapi/projects/3)) **(Initial docs done! https://ballotapi.org/docs)**
* [ ] Prototype - server that follows the docs ([see project](https://github.com/open-austin/ballotapi/projects/1))
* [ ] Website - website design/logo/content ([see project](https://github.com/open-austin/ballotapi/projects/2))
* [ ] Demo - example app that uses the API
* [ ] Testing - automated tests and sanity checks
* [ ] Maintenance - apps for maintaining the dataset
* [ ] Ops - tools for running/monitoring production

## License

### Project License
This entire project (including all source code, documentation, and ballot data)
is released into the [public domain](https://github.com/open-austin/ballotapi/blob/master/LICENSE).

### Dependency Licenses
While this project is released into the public domain, it does depend on other
open source projects. All dependencies are not included in the project license
are released under their respective open source licenses.

* Bootstrap - [MIT](https://github.com/twbs/bootstrap#copyright-and-license)
* Bootstrap.native - [MIT](https://github.com/thednp/bootstrap.native#license)
* Leaflet - [BSD-2-Clause](https://github.com/Leaflet/Leaflet/blob/master/LICENSE)
* Jekyll - [MIT](https://github.com/jekyll/jekyll/blob/master/LICENSE)
* Python - [PSFL](https://www.python.org/psf/license/)
* Psycopg2 - [LGPL](https://github.com/psycopg/psycopg2/blob/master/LICENSE)
* PostgreSQL - [PostgreSQL Licence](https://www.postgresql.org/about/licence/)
* PostGIS -  [GPLv2](https://postgis.net/docs/manual-dev/PostGIS_FAQ.html#license_faq)
* Redis - [BSD](https://redis.io/topics/license)

## Contributions
We love all types of contributions!

* Development: See the [CONTRIBUTING.md](https://github.com/open-austin/ballotapi/blob/master/CONTRIBUTING.md)
* Donations: Email donate@ballotapi.org
* Volunteering: Email volunteer@ballotapi.org

